/*
 
  ͻ                   
   OpenSource Library                    
  ͼ                   
   Author : Vitaly Checkryzhev (Virtualik) 
   E-Mail : virty1k@mail.ru                
   WWW    : http://www.str.ru/~virty       
   WWW    : http://virtualsoft.narod.ru    
   WWW    : http://chat.str.ru             
                                           
  VIRtUal Soft         All rights reserved 
 
  
*/

#include <vgagl.h>
#include <vga.h>
#include <math.h>

#define vmode G800x600x256
#define n 18
#define BGcolor 0
#define pi 3.141592658

GraphicsContext *physicalscreen;
GraphicsContext *virtualscreen;

class TDot
{
  float k;
  int cx, cy, dir, x, y, rad, col, ang;
  void Show (char);
  void Move ();

public:
  void Init (int, int, int);
  void Live ();
};

void TDot::Init (int r, int c, int a)
{
  k = 1;
  dir = 1;
  ang = a;
  rad = r;
  col = c;
  x = cx = vga_getxdim () / 2;
  y = cy = vga_getydim () / 2;
}

void TDot::Show (char flag)
{
  gl_circle (x, y, rad, col * char (flag));
}

void TDot::Move ()
{
  x = cx + round (k * cos (pi * ang / 180));
  y = cy + round (k * sin (pi * ang / 180));

  ang++;
  if (ang > 359)
    ang = 0;

  k += 0.1 * dir;
  if ((k > (cy - rad)) || (k < 1))
    dir *= -1;
}

void TDot::Live ()
{
  Show (false);
  Move ();
  Show (true);
}

int
main ()
{
  vga_init ();
  vga_setmode (vmode);
  gl_setcontextvga (vmode);

  physicalscreen = gl_allocatecontext ();
  gl_getcontext (physicalscreen);
  gl_setcontextvgavirtual (vmode);
  virtualscreen = gl_allocatecontext ();
  gl_getcontext (virtualscreen);

  gl_setcontext (virtualscreen);
  gl_clearscreen (BGcolor);

  int i, k;
  TDot dot[n];
  for (i = 0; i < n; i++)
    dot[i].Init(8 + 3 * char (i % 2 == 0),
		       10 + 5 * char (i % 2 == 0), (360 / n) * i);

  while (vga_getkey () == 0)
    {
      for (i = 0; i < n; i++)
	dot[i].Live();
      gl_copyscreen (physicalscreen);
    }
  vga_setmode (TEXT);
  return 0;
}
